#ifndef CPLAYER_H
#define CPLAYER_H

class CPlayer
{
public:
	entvars_t *	pev; //NULL if not connected (or invalid)
	
	int             m_InCheck;
	float           m_oldhealth;
	Vector          m_oldorigin;

	//Is player connected and is player entity valid
	inline bool IsValid()
	{
		return(!FNullEnt(pev));
	}
	
	//Is player alive
	inline bool IsAlive()
	{
		return(!((pev->deadflag != DEAD_NO) |
		         (pev->health <= 0) |
		         (pev->flags & FL_NOTARGET)));
	}
	
	inline bool IsSamePEV(const edict_t* ent)
	{
		return(&(ent->v)==pev);
	}
	
	//Get player entity
	inline edict_t *edict()
	{
		return(ENT(pev));
	}
	
	//Get entity offset
	inline EOFFSET eoffset()
	{
		return(OFFSET(pev));
	}
	
	//Get entity index
	inline int entindex()
	{
		return(ENTINDEX(edict()));
	}
	
	//Gets index to players array
	static CPlayer *GetPlayerFromArray(int index);
	inline static CPlayer *GetPlayerFromArray(edict_t *pEnt)
	{
		return(GetPlayerFromArray(FNullEnt(pEnt)?0:ENTINDEX(pEnt)));
	}
	
	//Is player in marine team
	inline bool IsMarine()
	{
		return(pev->team == 1);
	}
	
	//Store current health
	inline void SaveHealth()
	{
		m_oldhealth = pev->health;
	}
	
	//Get damage since stored health
	inline float GetDamage()
	{
		return(m_oldhealth - pev->health);
	}
	
	//Store current place
	inline void SaveOrigin()
	{
		m_oldorigin = pev->origin;
	}
	
	//Get stored place
	inline const Vector &GetOrigin()
	{
		return(m_oldorigin);
	}
};


#endif /*CPLAYER_H*/
