#ifndef marinebleed_H
#define marinebleed_H

#include <extdll.h>
#include <sdk_util.h>
#include <dllapi.h>
#include <meta_api.h>
#include <support_meta.h>

#include "cplayer.h"
#include "vers_plugin.h"


//
// Defines
//
#define UTIL_PointContents(vec)		POINT_CONTENTS(vec)
#define	UTIL_MakeVectors(vecAngles)	MAKE_VECTORS(vecAngles)


//
// Types/Classes
//
typedef struct 
{
	char * name;
	int index;
} DLL_DECALLIST;


//
// Globals
//
extern CPlayer players[33];
extern cvar_t* marinebleed_on;
extern cvar_t* marinebleed_gorelevel;
extern cvar_t* marinebleed_bloodspread;
extern short g_sModelIndexBloodSpray;
extern short g_sModelIndexBloodDrop;
extern DLL_DECALLIST gDecals[6];


//
// Extern functions
//
/*blood_util.cpp*/
extern void SpawnBlood(const Vector &vecSpot, float flDamage);
extern void TraceBleed(float flDamage, const Vector &vecStart, const Vector &vecDir, CPlayer * pVictim);
/*marinebleed.cpp*/
extern void InitializeDamageCheck(edict_t *pAttacker);
extern void CheckDamageAndSpreadBlood(edict_t *pAttacker, const Vector &AttackerOrigin, const Vector &AttackerAngles, const Vector &AttackerEyePos, int UseAngles);
extern void plugin_init(void);
/*dllapi.cpp*/
extern int __GetEntityAPI2(DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion);
extern int __GetEntityAPI2_Post(DLL_FUNCTIONS *pFunctionTable_Post, int *interfaceVersion);


//
// Inline functions
//
inline bool UTIL_MightCauseDamage(const edict_t *ed)
{
	if(FNullEnt(ed))
		return(false);
	
	const entvars_t * pev = &ed->v;
	
	if(pev->modelindex == 0)
		return(false);

	//bsp model check
	const char * str = STRING(pev->model);
	if(str && str[0]=='*')
		return(false);

	if(pev->deadflag != DEAD_NO) //it's dead..
		return(false);

	return(true);
}

inline void UTIL_TraceLine(const Vector &vecStart, const Vector &vecEnd, IGNORE_MONSTERS igmon, edict_t *pentIgnore, TraceResult *ptr)
{
	TRACE_LINE(vecStart, vecEnd, (igmon == ignore_monsters ? TRUE : FALSE), pentIgnore, ptr);
}

//Gets pointer to players array with index
inline CPlayer * CPlayer::GetPlayerFromArray(int index)
{
	if((index<1) | (index>gpGlobals->maxClients))
		return &players[0];
	return &players[index];
}



#endif /*marinebleed_H*/
